pipeline {
    agent {
        kubernetes {
            label 'jenkins-agent-pod'
            yaml """
apiVersion: v1
kind: Pod
metadata:
  labels:
    jenkins/label: jenkins-agent-pod
spec:
  containers:
    - name: jnlp
      image: jenkins/inbound-agent:latest
      args: ['\$(JENKINS_SECRET)', '\$(JENKINS_NAME)']
    - name: docker
      image: docker:latest
      command:
        - cat
      tty: true
      volumeMounts:
        - name: docker-socket
          mountPath: /var/run/docker.sock
  volumes:
    - name: docker-socket
      hostPath:
        path: /var/run/docker.sock
"""
        }
    }

    environment {
        DOCKER_HOST = "unix:///var/run/docker.sock"
        DOCKER_CREDENTIALS = 'dckr_pat_8ZdJR4BlPLWjL82K6-aTIVYHRVY'
    }

    stages {
        stage('Checkout') {
            steps {
                checkout([$class: 'GitSCM',
                        branches: [[name: '*/main']],
                        doGenerateSubmoduleConfigurations: false,
                        extensions: [],
                        userRemoteConfigs: [[
                            url: 'https://gitlab.com/sela-tracks/1099/students/serbeepsalot/finalproject',
                            credentialsId: 'glpat-gY8-yzK2KxAwW9JPcybg'
                        ]]
                ])
            }
        }

        stage('Test Docker') {
            steps {
                container('docker') {
                    script {
                        sh 'docker --version'
                        sh 'docker info'
                    }
                }
            }
        }

        stage('Build') {
            steps {
                container('docker') {
                    script {
                        sh 'docker build -t sirbeepsalot/my-python-app:latest .'
                    }
                }
            }
        }

        stage('Test') {
            steps {
                container('docker') {
                    script {
                        //dockerImage.inside {
                            // Add your test commands here
                            sh 'echo "Running tests..."'
                        //}
                    }
                }
            }
        }

        stage('Login to DockerHub') {
            steps {
                container('docker') {
                    sh "echo ${DOCKER_CREDENTIALS} | docker login -u sirbeepsalot --password-stdin"                		
                    echo 'Login Completed'
                }
            }
        }

        stage('Push') {
            steps {
                container('docker') {
                    sh 'docker push sirbeepsalot/my-python-app:latest'
                }
            }
        }

        // stage('Deploy') {
        //     steps {
        //         container('kubectl') {
        //             script {
        //                 kubernetesDeploy(configs: 'k8s/*.yaml', kubeconfigId: 'kube-config')
        //             }
        //         }
        //     }
        // }

        stage('Docker logout') {
            steps {
                container('docker') {
                    script {
                        sh 'docker logout'
                    }
                }
            }
        }
    }
}
